init()
{
	level thread onPlayerConnect();
}

onPlayerConnect()
{
	for(;;)
	{
	level waittill("connected", player);
	if(level.ex_healthbar)
		{
		player thread onPlayerSpawned();
		player thread onPlayerKilled();
		}
	}
}

onPlayerSpawned()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("spawned_player");
		self thread healthBar();
	}
}

onPlayerKilled()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("killed_player");
		if(isDefined(self.ex_healthback)) self.ex_healthback destroy();
      	if(isDefined(self.ex_healthbar)) self.ex_healthbar destroy();
      	if(isDefined(self.ex_healthcross)) self.ex_healthcross destroy();
	}
}

healthBar()
{
	if(level.inPrematchPeriod)
	level waittill("prematch_over");

	if(isDefined(self.ex_healthbar)) return;

	self.ex_healthcross = newClientHudElem(self);
	self.ex_healthcross.x = 110;
	self.ex_healthcross.y = 414;
	self.ex_healthcross.alignX = "right";
	self.ex_healthcross.alignY = "top";
	self.ex_healthcross setShader("hint_health", 10, 10);

	self.ex_healthback = newClientHudElem(self);
	self.ex_healthback.x = 6;
	self.ex_healthback.y = 415;
	self.ex_healthback.alignX = "left";
	self.ex_healthback.alignY = "top";
	self.ex_healthback.alpha = .7;
	self.ex_healthback setShader("progress_bar_fg", 90, 7);

	self.ex_healthbar = newClientHudElem(self);
	self.ex_healthbar.x = 7;
	self.ex_healthbar.y = 416;
	self.ex_healthbar.alignX = "left";
	self.ex_healthbar.alignY = "top";
	self.ex_healthbar.alpha = .5;
	self.ex_healthbar setShader("progress_bar_fill", 88,5);
	self.ex_healthbar.color = ( 0, 1, 0);

	self thread healthUpdate();
}

healthUpdate()
{
	self endon("disconnect");
	self notify("end_healthbar");

	oldhealth = self.health;
	width = undefined;
	
	for(;;)
	{
		wait (0.1 * level.fps_multiplier);

		if(isPlayer(self) && isDefined(self.health) && self.health != oldhealth)
		{
			health = self.health / self.maxhealth;
		
			width = int(health * 88);
					
			if(width < 1) width = 1;

			if(isDefined(self.ex_healthbar))
			{					
				self.ex_healthbar setShader("progress_bar_fill", width, 5);
				self.ex_healthbar.color = ( 1.0 - health, health, 0);
			}
			
			oldhealth = self.health;
		}
	}
}
