
getgtstring(gt)
{
	switch(gt)
	{
		case "dm":
			gtstring = &"MAPS_DEATHMATCH";
			break;
		case "dom":
			gtstring = &"MAPS_DOMINATION";
			break;			
		case "koth":
			gtstring = &"MAPS_KING_OF_THE_HILL";
			break;
		case "sab":
			gtstring = &"MAPS_SABATOGE";
			break;
		case "sd":
			gtstring = &"MAPS_SEARCH_AND_DESTROY";
			break;
		case "war":
			gtstring = &"MAPS_TEAM_DEATHMATCH";
			break;
		case "ctf":
			gtstring = &"MAPS_CAPTURE_THE_FLAG";
			break;	
		default:
			gtstring = gt;
			break;
	}

	return gtstring;
}

getgtstringshort(gt)
{
	switch(gt)
	{
		case "dm":
			gtstring = &"MAPS_DM";
			break;
		case "dom":
			gtstring = &"MAPS_DOM";
			break;
		case "koth":
			gtstring = &"MAPS_KOTH";
			break;
		case "sab":
			gtstring = &"MAPS_SAB";
			break;
		case "sd":
			gtstring = &"MAPS_SD";
			break;
		case "war":
			gtstring = &"MAPS_WAR";
			break;
		case "ctf":
			gtstring = &"MAPS_CTF";
			break;
		default:
			gtstring = gt;
			break;
	}

	return gtstring;
}

getmapstring(map)
{
  level.msc = undefined;
  
  switch(map)
  {
    // Stock maps    
    case "mp_backlot":            	mapstring = &"MPUI_BACKLOT";    	level.msc = true; break;
    case "mp_bloc":              	mapstring = &"MPUI_BLOC";    		level.msc = true; break;
    case "mp_bog":               	mapstring = &"MPUI_BOG";    		level.msc = true; break;
    case "mp_cargoship":            mapstring = &"MPUI_CARGOSHIP";   	level.msc = true; break;
    case "mp_citystreets":          mapstring = &"MPUI_CITYSTREETS";    level.msc = true; break;
    case "mp_convoy":               mapstring = &"MPUI_CONVOY";    		level.msc = true; break;
    case "mp_countdown":            mapstring = &"MPUI_COUNTDOWN";      level.msc = true; break;
    case "mp_crash":              	mapstring = &"MPUI_CRASH";   		level.msc = true; break;
	case "mp_crash_snow":           mapstring = &"MPUI_CRASH_SNOW";    	level.msc = true; break;
    case "mp_crossfire":            mapstring = &"MPUI_CROSSFIRE";   	level.msc = true; break;
    case "mp_farm":                	mapstring = &"MPUI_FARM";     		level.msc = true; break;
    case "mp_overgrown":            mapstring = &"MPUI_OVERGROWN";    	level.msc = true; break;
    case "mp_pipeline":             mapstring = &"MPUI_PIPELINE";     	level.msc = true; break;
    case "mp_shipment":           	mapstring = &"MPUI_SHIPMENT";		level.msc = true; break;
    case "mp_showdown":             mapstring = &"MPUI_SHOWDOWN";       level.msc = true; break;
	case "mp_strike":               mapstring = &"MPUI_STRIKE";      	level.msc = true; break;
	case "mp_vacant":               mapstring = &"MPUI_VACANT";      	level.msc = true; break;
	
	default: mapstring = map; break;
  }

  return mapstring;
}

StringToArray(pString)
{
	thread extreme\_ex_logfile::Log("StringToArray");

	//Convert a string to an array of words
	j=0;
	temparr[j] = "";

	for(i=0;i<pString.size;i++)
	{
		if(pString[i] == " ")
		{
			j++;
		}
		else
		{
			if (!isdefined(temparr[j]))
				temparr[j] = "";

			temparr[j] += pString[i];
		}
	}
	return temparr;
}

trim(s)
{
	thread extreme\_ex_logfile::Log("trim");

	if( (s=="") )
		return "";

	s2="";
	s3="";

	i=0;
	while( (i<s.size) && (s[i]==" ") )
		i++;

	// String is just blanks?
	if(i==s.size)
		return "";

	for(;i<s.size;i++)
	{
		s2 += s[i];
	}

	i=s2.size-1;
	while(s2[i]==" " && i>0)
		i--;

	for(j=0;j<=i;j++)
	{
		s3 += s2[j];
	}

	return s3;
}

DisplayMapRotation()
{
	level endon("ex_gameover");

	thread extreme\_ex_logfile::Log("DisplayMapRotation");

	level.ex_pausesvrmsg = true;

	endmsg = &"MAPROTATION_NORMAL";

	//if(level.ex_randommaprotation) endmsg = &"MAPROTATION_RANDOM";
	//if(level.ex_pbrotate) endmsg = &"MAPROTATION_PLAYER";
	//if(level.ex_mapvote) endmsg = &"MAPROTATION_VOTING";

	iprintln(&"CUSTOM_SERVER_NAME", endmsg);
	wait 2;

	if(level.ex_mapvote)
	{
		level.ex_pausesvrmsg = false;
		return;
	}

	if(!isdefined(level.MapRotation)) GetMapRotation();
    
	sGametype = getgtstring(level.MapRotation[0]["gametype"]);  
	sMapName = getmapstring(level.MapRotation[0]["map"]); 
	bCustomMap = IsCustomMap(level.MapRotation[0]["map"]);
        
	if(level.ex_svrmsg_info >= 1)
	{
		iprintln(&"MAPROTATION_NEXT_MAP", sMapName);
		wait 2;
	}
  
	if(level.ex_svrmsg_info >= 2)
	{
		if(bCustomMap)
		{
		//display a warning that the next map is a custom map
		iprintln(&"MAPROTATION_CUSTOM_NEXT");
		wait 2;
		}
  
		iprintln(&"MAPROTATION_NEXT_GT", sGametype);
		wait 2;
	}

	// if no map rotation display, end here!
	if(!level.ex_svrmsg_rotation)
	{
		level.ex_pausesvrmsg = false;
		return;
	}

	iprintln(&"MAPROTATION_TITLE");
	wait 2;
  
	for( i = 0; i < level.MapRotation.size; i++)
	{
		sG = getgtstring(level.MapRotation[i]["gametype"]); 
		sMN = getmapstring(level.MapRotation[i]["map"]);  
		bCM = IsCustomMap(level.MapRotation[i]["map"]); 
            
		if (bCM)
		MapColour = &"COLOUR_GREEN";
		else
		MapColour = &"COLOUR_WHITE";

		wait 1;
		iprintln(sG, &"MISC_BLANK_LINE_TXT", MapColour, sMN, &"COLOUR_WHITE");
		wait 1;
	}

	// start up server message again
	level.ex_pausesvrmsg = false;
}

GetMapRotation(DontUseCurrent)
{
  thread extreme\_ex_logfile::Log("GetMapRotation");

  maprotcur = trim(getDvar("sv_maprotationcurrent"));  

  if ( maprotcur == "" )
    return;
  
	//convert to array of strings
	maprotarray = StringToArray(maprotcur);
  
	//now go through array of words getting gametypes and maps
	sGametype = getDvar("g_gametype");
	arraypos = 0;
	mapnum = 0;
  
	while (arraypos < maprotarray.size)
	{
    if ( maprotarray[arraypos] == "gametype" )
		{
			//found in array string "gametype type map mapname"
			sGametype = maprotarray[arraypos + 1];
			level.MapRotation[mapnum]["gametype"] = maprotarray[arraypos + 1];
			level.MapRotation[mapnum]["map"] = maprotarray[arraypos + 3];
			arraypos = arraypos + 4;
		}
		else
		{
			//no gametype so presumably just a map "map mapname"
			level.MapRotation[mapnum]["gametype"] = sGametype;
			level.MapRotation[mapnum]["map"] = maprotarray[arraypos + 1];
			arraypos = arraypos + 2;      
		}
    
		mapnum++;
	}
  
	if(!isdefined(DontUseCurrent))
	{
		//now add the current map as it won't be on there!
		level.MapRotation[mapnum]["gametype"] = level.ex_currentgt;
		level.MapRotation[mapnum]["map"] = level.ex_currentmap;
	}
  
	return; 
}

IsCustomMap(map)
{
	thread extreme\_ex_logfile::Log("IsCustomMap");

	switch(map)
	{
		case "mp_backlot":
	    case "mp_bloc":   
	    case "mp_bog":    
	    case "mp_cargoship":
	    case "mp_citystreets":
	    case "mp_convoy":     
	    case "mp_countdown":  
	    case "mp_crash":      
		case "mp_crash_snow": 
	    case "mp_crossfire":  
	    case "mp_farm":       
	    case "mp_overgrown":  
	    case "mp_pipeline":   
	    case "mp_shipment":   
	    case "mp_showdown":   
		case "mp_strike":     
		case "mp_vacant":     
		return false;
      
		default:
		return true;
	}
}